﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.POI;
using Styx.CommonBot.Profiles;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

using Action = Styx.TreeSharp.Action;

namespace Feathers {
    class Feathers: BotBase {
        public override string Name {
            get {
				return "Feathers";
			}
        }

        public override PulseFlags PulseFlags {
            get {
				return PulseFlags.All;
			}
		}

        static int castFeathers = 0;
        public override void Pulse() {
			if (castFeathers == 0)
				return;

			SpellManager.Cast("Angelic Feather");
			SpellManager.ClickRemoteLocation(StyxWoW.Me.Location);

			Lua.DoString(@"print('[Feathers]\124cFF15E61C Activated!')");
			Lua.DoString("SpellStopTargeting(); castFeathers = 0;");
			castFeathers = 0;
        }

        private Composite _root;
        public override Composite Root {
            get {
                return _root ?? (_root = new PrioritySelector(logic()));
            }
        }

        public override void Start() {
			ProfileManager.LoadEmpty();
        }

		private static Composite logic() {
            return new Action(delegate {
				castFeathers = Lua.GetReturnVal<int>("return castFeathers", 0);
			});
        }
    }
}